// Log.cpp: implementation of the Log class.
//
//////////////////////////////////////////////////////////////////////

//#include "stdafx.h"
#include "Log.h"
#include <fstream.h>
#include <iostream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Log::Log(bool append)
{
	if (append)
		f.open(LOGFILE,ios::out|ios::app);
	else
		f.open(LOGFILE,ios::out|ios::trunc);
	f<<"============================================================================\n";
	f<<"New log stream...\n=================\n\n";
	cArea=1;
	areaStr[0][0]='L';
	areaStr[0][1]='o';
	areaStr[0][2]='g';
	areaStr[0][3]=0;
	areaPtr[0]=(long)this;
	count=0;
}

Log::~Log()
{
	this->f.close();
}

void Log::addArea(long ptr, char *name)
{
/*	int i, j=cArea;
	for (i=0; i<cArea; ++i)
		if (areaPtr[i]==ptr)
			j=i;
	if (j<MAX_AREAS) {
		areaPtr[j]=ptr;
		i=-1;
		do {
			++i;
			areaStr[j][i]=name[i];
		} while (name[i]>20 && i<MAX_STR_LENGTH-2);
		areaStr[j][i]=0;
		if (j==cArea)
			cArea++;
	}
*/
}

void Log::addArea(long ptr, char *name, int no)
{
/*
	int i, j=cArea;
	for (i=0; i<cArea; ++i)
		if (areaPtr[i]==ptr)
			j=i;
	if (j<MAX_AREAS) {
		areaPtr[j]=ptr;
		i=-1;
		do {
			++i;
			areaStr[j][i]=name[i];
		} while (name[i]>20 && i<MAX_STR_LENGTH-10);
		areaStr[j][i]=' ';
		areaStr[j][i+1]='0'+(no/1000)%10;
		areaStr[j][i+2]='0'+(no/100)%10;
		areaStr[j][i+3]='0'+(no/10)%10;
		areaStr[j][i+4]='0'+no%10;
		areaStr[j][i+5]=0;
		if (j==cArea)
			cArea++;
	}
*/
}

char* Log::getName(long ptr)
{
/*	int i;
	for (i=cArea-1; i>=0; --i)
		if (areaPtr[i]==ptr)
			return areaStr[i];
	this->error((long)this,"Unknown Log Area in getName(), this->cArea=",cArea);
*/	return "";
}

void Log::error(long ptr, char *msg)
{
	f<<"ERROR: "<<getName(ptr)<<", "<<msg<<endl;
	f.flush();
}

void Log::error(long ptr, char *msg, int no)
{
	f<<"ERROR: "<<getName(ptr)<<", "<<msg<<' '<<no<<endl;
	f.flush();
}

void Log::debug(long ptr, char *msg)
{
	f<<"DEBUG: "<<getName(ptr)<<", "<<msg<<endl;
	f.flush();
}

void Log::debug(long ptr, char *msg, int no)
{
	f<<"DEBUG: "<<getName(ptr)<<", "<<msg<<' '<<no<<endl;
	f.flush();
}

void Log::log(long ptr, char *msg)
{
	f<<++count<<". "<<getName(ptr)<<", "<<msg<<endl;
	f.flush();
}

void Log::log(long ptr, char *msg, int no)
{
	f<<++count<<". "<<getName(ptr)<<", "<<msg<<' '<<no<<endl;
	f.flush();
}

void Log::log(long ptr, char* msg1, char* msg2, char* msg3)
{
	f<<++count<<". "<<getName(ptr)<<", "<<msg1<<msg2<<msg3<<endl;
	f.flush();
}
