// Log.h: interface for the Log class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(LOG_H)
#define LOG_H

//#if _MSC_VER > 1000
//#pragma once
//#endif // _MSC_VER > 1000

#include <fstream.h>
#include "genTypes.h"

const int MAX_AREAS = 10;
const int MAX_STR_LENGTH = 50;

class Log  
{
public:
	void debug(long ptr, char* msg, int no);
	void debug(long ptr, char* msg);
	void error(long ptr, char* msg, int no);
	void error(long ptr, char* msg);
	void log(long ptr, char* msg);
	void log(long ptr, char* msg, int no);
	void log(long ptr, char* msg1, char* msg2, char* msg3);
	void addArea(long ptr, char *name, int no);
	void addArea(long ptr, char *name);
	Log(bool append);
	virtual ~Log();
private:
	long count;
	char* getName(long ptr);
	ofstream f;
	long areaPtr[MAX_AREAS];
	int cArea;
	char areaStr[MAX_STR_LENGTH][50];
};

#endif // !defined(LOG_H)
