#ifndef SCCONST_H
#define SCCONST_H

#include "/home/jonatan/robocup/v2/evolve/genTypes.h"

// Directories and Programs
const char* scdir = "$HOME/robocup/v2/scriptcreator/";
const char* rundir = "$HOME/robocup/v2/rundir/";
const char* goalkeeper = "$HOME/robocup/v2/RSGoalie/src/Team -goalie true";
const char* player = "$HOME/robocup/v2/RSTest/src/Team -goalie false";
const char* evolver = "$HOME/robocup/v2/evolve/evolve";
const char* trainer = "$HOME/robocup/v2/trainer/trainer -host localhost";
const char* eval_fitness = "$HOME/robocup/v2/fitness/fitness";

// Game parameters
const char* connection_delay = "sleep 2";
const int game_length = 440;
const int teamSize = 8;
const bool goalie = true;

// Experimental parameters
const int starting_gen = 45;
const int nOfGenerations = 40;
const int nOfGamesPerPlayer = 2;
const int nOfPlayers = POPULATION_SIZE;
const char* logfile = "explog.txt";

#endif // !SCCONST_H
